<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="p-4">

  <app-breadcrumbs [forceReload]="tenantId"></app-breadcrumbs>

  <div
    id="typologyListLabel"
    class="h3"
    [innerText]="typologyMessages.TYPOLOGY_MANAGEMENT_TITLE">
  </div>

  <!-- Header -->

  <div class="mt-3 mb-2 d-flex align-items-start">

    <button
      ls-button
      class="me-2"
      [icon]="commonIcons.CREATE_ICON"
      [text]="typologyMessages.CREATE_TYPOLOGY_BUTTON_TITLE"
      (click)="fetchAndOpenTypeModal()">
    </button>

    <button
      type="button"
      class="btn btn-outline-primary me-2"
      [ngbTooltip]="commonMessages.FOLD_ALL"
      (click)="onCollapseButtonClicked(true)">
      <fa-icon [icon]="compressIcon"></fa-icon>
    </button>

    <button
      type="button"
      class="btn btn-outline-primary me-2"
      [ngbTooltip]="commonMessages.EXPAND_ALL"
      (click)="onCollapseButtonClicked(false)">
      <fa-icon [icon]="expandIcon"></fa-icon>
    </button>

    <app-search-bar
      class="search-input"
      (debouncedKeyup)="updateSearchTerm($event)"
      [placeholder]="typologyMessages.SEARCH_TYPES">
    </app-search-bar>

    <span class="flex-grow-1"></span>
    <span class="p-1 px-2" [innerText]="commonMessages.PAGINATION_SIZE_LABEL"></span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="requestTypology(true)">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>
  </div>

  <!-- List -->

  <table
    aria-labelledby="typologyListLabel"
    class="bg-white table table-fixed table-striped table-borderless border shadow-sm table-text-overflow">
    <thead class="border">
      <tr>
        <th
          scope="col"
          class="th-sm"
          (click)="onRowOrderClicked()">
          <fa-icon
            [icon]="asc ? caretUp : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.NAME }}
        </th>
        <th
          *ngIf="userPreferences.showAdminIds"
          scope="col"
          class="col-id-fixed-size"
          [innerText]="commonMessages.ID">
        </th>
        <th
          scope="col"
          class="col-buttons-fixed-size col-buttons-3-buttons"
          [innerText]="commonMessages.ACTIONS">
        </th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let typologyEntity of typologyList">
        <td
          class="overflow-hidden text-overflow-ellipsis"
          (click)="onCaretClicked(typologyEntity)">
          <span
            *ngIf="isSubtype(typologyEntity)"
            class="sub-type-padding">
          </span>
          <fa-icon
            [ngClass]="{'invisible' : (typologyEntity.childrenCount <= 0)}"
            [ngbTooltip]="(collapseAll !== reversedIds.has(typologyEntity.id)) ? commonMessages.EXPAND : commonMessages.FOLD"
            [icon]="(collapseAll !== reversedIds.has(typologyEntity.id)) ? caretRight : caretDown"
            [fixedWidth]="true">
          </fa-icon>
          {{ typologyEntity.name | namePipe }}
        </td>
        <td *ngIf="userPreferences.showAdminIds">
          <span
            class="font-monospace text-size-small"
            [innerText]="typologyEntity.id | namePipe">
          </span>
        </td>
        <td class="text-end">
          <button
            *ngIf="isType(typologyEntity)"
            (click)="fetchAndOpenSubtypeModal(typologyEntity.id, null)"
            [title]="typologyMessages.ADD_SUBTYPE_BUTTON_TITLE"
            class="btn btn-sm btn-outline-primary me-2"
            type="button">
            <fa-icon [icon]="commonIcons.ADD_ICON"></fa-icon>
          </button>
          <button
            *ngIf="isType(typologyEntity)"
            (click)="fetchAndOpenTypeModal(typologyEntity)"
            [title]="commonMessages.EDIT"
            class="btn btn-sm btn-outline-primary me-2"
            type="button">
            <fa-icon [icon]="commonIcons.EDIT_ICON"></fa-icon>
          </button>
          <button
            *ngIf="isSubtype(typologyEntity)"
            (click)="fetchAndOpenSubtypeModal(typologyEntity.parentId, typologyEntity)"
            [title]="commonMessages.EDIT"
            class="btn btn-sm btn-outline-primary me-2"
            type="button">
            <fa-icon [icon]="commonIcons.EDIT_ICON"></fa-icon>
          </button>
          <button
            (click)="onDeleteButtonClicked(typologyEntity)"
            [title]="commonMessages.DELETE"
            class="btn btn-sm btn-outline-danger"
            type="button">
            <fa-icon [icon]="commonIcons.DELETE_ICON"></fa-icon>
          </button>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="typologyList"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_TYPOLOGY_LIST">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="requestTypology(false)">
  </ngb-pagination>

</div>
